/**
 * Copyright (C) 2010-2012 Agrosense info@agrosense.eu
 *
 * Licensed under the Eclipse Public License - v 1.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *         http://www.eclipse.org/legal/epl-v10.html
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package nl.cloudfarming.client.geoviewer.jxmap.layerlist;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import javax.swing.Action;
import nl.cloudfarming.client.geoviewer.Layer;
import org.openide.nodes.Children;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;

/**
 *
 * @author Timon Veenstra
 */
public class FilterLayerListChildren extends FilterNode.Children {

    public FilterLayerListChildren(Node or) {
        super(or);
    }

    @Override
    protected Node[] createNodes(Node object) {
        List<Node> result = new ArrayList<Node>();
        for (Node node : super.createNodes(object)) {
            if (accept(node)) {
                final Layer layer = object.getLookup().lookup(Layer.class);

                result.add(new FilterNode(node, Children.LEAF) {

                    @Override
                    public Action[] getActions(boolean context) {


                        List<Action> superActions = new ArrayList();

                        if (super.getActions(context) != null && super.getActions(context).length > 0) {
                            superActions.addAll(Arrays.asList(super.getActions(context)));
                        }
                        //FIXME
//
//                        superActions.add(new RemoveLayerAction() {
//
//                            @Override
//                            public void actionPerformed(ActionEvent e) {
//                                removeLayerNode(getOriginal());
//                            }
//                        });
//                        superActions.add(new SettingsForLayerAction(getLayerInfo(layer), layer));
//                        superActions.add(new VisibilityLayerAction(getLayerInfo(layer)) {
//
//                            @Override
//                            public void actionPerformed(ActionEvent ae) {
//                                super.actionPerformed(ae);
//                                fireIconChange();
//                            }
//                        });
                        return super.getActions(context);
                    }
                });
            }
        }
        return result.toArray(new Node[0]);
    }

    /**
     * only accept child nodes which have a LayerObject in their lookup
     *
     * @param node
     * @return
     */
    private boolean accept(Node node) {
        return (node.getLookup().lookup(Layer.class) != null);
    }
}
